#cloud-config

{#- filter docker-compose files for which to generate services -#}
{%- set files = files | default([]) %}
{%- set docker_compose_files = files | selectattr("filename", "match", "docker-compose(.*?)?\\.ya?ml") %}

repo_update: true
repo_upgrade: all
package_upgrade: true

{% if volume_disk is defined and volume_disk %}
# prepare volume, if requested
# cant use builtin format module since $DISK is attached later and dynamically discovered in runcmd
# fs_setup:
#   - device: "{{ volume_disk }}"
#     partition: auto
#     filesystem: ext4
#     label: external_data

# but we can add the fstab mount here
mounts:
    # systemd options add mount dependency to container app service, nofail to allow attach/detaching of volume without breaking app
  - [ LABEL=external_data, "{{ mountpoint }}", ext4, "defaults,nofail,x-systemd.wanted-by=app.service,x-systemd.before=app.service", "0", "2" ]
{% endif %}

write_files:
  # write out envvar file
  # also do envvar ip address -> hostname subst
  - path: /var/app/.env
    permissions: 0644
    content: |
      {% set hosts=dict() -%}
      {% for name, value in env.items() -%}
      {%   if value and value is ansible.utils.ip_address -%}
      {%     set svc_host = "unfurl.svc-" ~ {'to_dns_label': name} | eval -%}
      {%     set _ = hosts.update({svc_host: value}) -%}
      {%     set value = svc_host -%}
      {%   endif -%}
      {{ name }}={{ value if value is not none else '' }}
      {% endfor %}

  # application container
  - path: /var/app/docker-compose-app.yaml
    permissions: 0644
    content: |
      {% filter indent(width=6, first=false) -%}
      {% include "./docker-compute-host/templates/docker-compose-template.yaml.j2" -%}
      {% endfilter %}

    {% set _ = docker_compose_files.append({ 'name': 'app', 'filename': 'docker-compose-app.yaml' }) -%}

  {%- if enable_caddy %}
  # caddy container
  - path: /var/app/docker-compose-caddy.yaml
    permissions: 0644
    content: |
      {% filter indent(width=6, first=false) -%}
      {% include "./docker-compute-host/templates/docker-compose-caddy.yaml" -%}
      {% endfilter %}

    {% set _ = docker_compose_files.append({ 'name': 'caddy', 'filename': 'docker-compose-caddy.yaml' }) -%}
  {% endif -%}

  {%- for f in files %}
  - path: /var/app/{{ f.filename }}
    permissions: {{ "0755" if f.filename[:-2] == "sh" else "0644" }}
    content: {{ f.content }}
    encoding: b64
  {% endfor -%}

  # add app services for each compose unit
  {% for c in docker_compose_files -%}
  - path: /etc/systemd/system/{{ c.name or "app" }}.service
    permissions: 0644
    content: |
      [Unit]
      Description=Docker Compose Service ({{ c.name or "app" }})
      Requires=docker.service
      {% for f in docker_compose_files if f.name != c.name -%}
      Requires={{ f.name }}.service
      {% endfor -%}

      After=docker.service
      {% if enable_caddy and c.name != "caddy" -%}
      Before=caddy.service
      Wants=caddy.service
      {% endif %}

      [Service]
      Type=oneshot
      RemainAfterExit=yes
      WorkingDirectory=/var/app
      EnvironmentFile=/var/app/.env
      ExecStartPre=-docker compose -f {{ c.filename }} pull --ignore-pull-failures
      ExecStart=docker compose -f {{ c.filename }} up -d
      ExecStop=docker compose -f {{ c.filename }} down -t 15

      [Install]
      WantedBy=multi-user.target

  {% endfor -%}

  # units to restart app if stored envvars change
  - path: /etc/systemd/system/app-monitor.service
    permissions: 0644
    content: |
      [Unit]
      Description=Restart application

      [Service]
      Type=oneshot
      WorkingDirectory=/var/app
      EnvironmentFile=/var/app/.env
      ExecStart=/usr/bin/systemctl restart app.service

      [Install]
      WantedBy=multi-user.target

  - path: /etc/systemd/system/app-monitor.path
    permissions: 0644
    content: |
      [Unit]
      Description=Watch for updates to .env
      After=app.service

      [Path]
      PathChanged=/var/app/.env

      [Install]
      WantedBy=multi-user.target

# install packages that don't depend on disk setup now
packages:
  # - docker.io # installed after mount
  - jq
  - nvme-cli
  - wget

runcmd:
  # ensure mountpoint dir is present
  # app still writes here even if no volume, so always create
  - mkdir -p "{{ mountpoint }}"

  {% if volume_disk -%}
  # spin until disk is ready, and format once it is
  - |
    export DISK="{{ volume_disk }}"
    TRIES=30 # * 10s = 5m
    PLATFORM=$(cloud-init query v1.platform)

    spin () {
      until test -b "$DISK"; do
        echo "waiting for $DISK... ($TRIES left)"
        sleep 10

        case $PLATFORM in
          ec2)
            # also look in nvme disks
            for NVME in $(ls /dev/ | awk '/nvme.n1$/{ print "/dev/" $1 }'); do
              echo "  checking $NVME"
              VENDOR=$(nvme amzn id-ctrl -v $NVME -o json | jq .bdev -r)
              [ "$VENDOR" = "$DISK" ] && export DISK="$NVME"
            done
            ;;
          gce)
            # needs no special steps
            ;;
        esac

        TRIES=$(( TRIES - 1 ))
        [ $TRIES -gt 0 ] || return 1
      done
    }

    # wait for disk
    if spin; then
      # format disk if not already formatted
      if lsblk "$DISK" -o FSTYPE -rn | grep -q ext4 ; then
        echo "$DISK already formatted"
      else
        echo "formatting $DISK as ext4..."
        mkfs -t ext4 -L external_data "$DISK"
      fi

      mount "{{ mountpoint }}"  # ensure disk is mounted
    else
      echo "...timed out"
    fi

  # symlink docker volume dir to data path
  - mkdir -p /var/app/data/docker_volumes /var/lib/docker &&
    ln -s /var/app/data/docker_volumes /var/lib/docker/volumes
  {% endif -%}

  # Install docker here after volume has been mounted for volume dir symlink
  - apt install -y docker.io

  # Install latest docker-compose plugin from upstream
  # (not packaged in distro repo)
  - mkdir -p /usr/local/lib/docker/cli-plugins
  - wget -q https://github.com/docker/compose/releases/download/v2.15.1/docker-compose-linux-$(uname -m)
    -O /usr/local/lib/docker/cli-plugins/docker-compose
  # verify SHA
  - |
    SHA_x86_64="bcfd9ea51dee4c19dccdfaeef0e7956ef68bf14f3d175933742061a7271ef0f5"
    SHA_aarch64="14d31297794868520cb2e61b543bb1c821aaa484af22b397904314ae8227f6a2"
    SHA_ARCH=$(eval "echo \$SHA_$(uname -m)") # ash shell does not have indirection

    SHA_ACTUAL="$(sha256sum /usr/local/lib/docker/cli-plugins/docker-compose | cut -d' ' -f1)"
    if [ $SHA_ARCH != $SHA_ACTUAL ]; then
      echo
      echo "== COMPOSE SHA CHECK FAILED! =="
      echo "expected: $SHA_ARCH"
      echo "  actual: $SHA_ACTUAL"
      echo
      exit 1
    fi

  - chmod +x /usr/local/lib/docker/cli-plugins/docker-compose
  - systemctl enable --now docker.socket

  # Create network used by compose service-
  - "[ $(docker network list -q --filter=name=web) ] || docker network create web"

  # pull image before starting app
  {% if registry_user is defined and registry_user and registry_password and registry_url -%}
  - docker login -u {{ registry_user }} -p {{ registry_password }} {{ registry_url }}
  {% endif -%}
  - |
    while ! yes | docker pull '{{ image }}'; do
      echo '{{ image }} not available yet. Sleeping for 30 seconds';
      sleep 30;
    done

  # Enable systemd services responsible for managing Docker Compose services
  - systemctl daemon-reload && systemctl enable --now app app-monitor.path
